
package agent.awtwindow;

import java.awt.*;

import agentspace.Context;
import agentspace.Agent;
import agentspace.Mobile;
import agentspace.event.AgentEvent;

public class AWTWindow implements Agent, Mobile {
	AgentFrame frame = null;

	class AgentFrame extends Frame {
		TextArea area;
		public AgentFrame() {
			super("Window Agent");
			area = new TextArea(80, 20);
			area.setText("Input text here.\n");
			area.setVisible(true);
			add(area);
			setSize(300, 200);
		}
	}
	
	public AWTWindow() {
		System.out.println("AWTWindow: an instance created.");
	}
	/* 
	 * @see agentspace.SerialiableAgent#create(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void create(AgentEvent evt, Context context) {
		System.out.println("AWTWindow: method create() called");
		frame = new AgentFrame();
		frame.setVisible(true);
	}
	/* 
	 * @see agentspace.SerialiableAgent#destroy(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void destroy(AgentEvent evt, Context context) {
		System.out.println("AWTWindow: method destroy() called");
		frame.setVisible(false);
	}
	/* 
	 * @see agentspace.SerialiableAgent#suspend(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void suspend(AgentEvent evt, Context context) {
		System.out.println("AWTWindow: method suspend() called");
		frame.setVisible(false);
	}

	/* 
	 * @see agentspace.SerialiableAgent#resume(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void resume(AgentEvent evt, Context context) {
		System.out.println("AWTWindow: method resume() called");
		frame.setVisible(true);
	}
	/* 
	 * @see agentspace.MobileAgent#arrive(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void arrive(AgentEvent evt, Context context) {
		System.out.println("AWTWindow: method arrive() called");
		frame.setVisible(true);
	}
	/* 
	 * @see agentspace.MobileAgent#leave(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void leave(AgentEvent evt, Context context) {
		System.out.println("AWTWindow: method leave() called");
		frame.setVisible(false);
	}
}
