/*
 * Created on 2005/05/30
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package agent.chat;

import java.io.IOException;
import java.net.URL;

import agentspace.Agent;
import agentspace.Context;
import agentspace.Duplicatable;
import agentspace.InvalidURLException;
import agentspace.Mobile;
import agentspace.event.AgentEvent;

/**
 * @author ichiro
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Chat implements Agent, Mobile, Duplicatable {
	ChatWindow window = null;
	ChatReceiver receiver = null;
	ChatSender sender = null;
	Thread receiverThread = null;
	String parentHost = null;
	String childHost = null;
	int parentPort = -1;
	int childPort = -1;
	
	/* (non-Javadoc)
	 * @see agentspace.Agent#create(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void create(AgentEvent evt, Context context) {
		window = new ChatWindow();
		window.setContext(context);
		window.initWindow();
		window.setVisible(true);
	}

	/* (non-Javadoc)
	 * @see agentspace.Agent#destroy(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void destroy(AgentEvent evt, Context ctxt) {
		window.setVisible(false);
		if (receiverThread != null) {
			receiverThread.interrupt();
		}
	}

	/* (non-Javadoc)
	 * @see agentspace.Mobile#arrive(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void arrive(AgentEvent evt, Context context) {
		System.out.println("Chat: arrive() called");
		receiver = new ChatReceiver(7010);
		receiverThread = new Thread(receiver);
		receiverThread.start();
		if (parentHost != null) {
			sender = new ChatSender(parentHost, 7011);
		}
		System.out.println("Chat(child): parent:"+parentHost+" to child:"+childHost);
		window.setContext(context);
		window.setChatReceiver(receiver);
		window.setChatSender(sender);
		window.setTitle("Chat (clone)");
		window.setVisible(true);
	}

	/* (non-Javadoc)
	 * @see agentspace.Mobile#leave(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void leave(AgentEvent evt, Context ctxt) {
		window.setVisible(false);
		if (receiverThread != null) {
			receiverThread.interrupt();
			receiverThread = null;
		}
	}

	/* (non-Javadoc)
	 * @see agentspace.Duplicatable#duplicate(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void duplicate(AgentEvent evt, Context context) {
		URL url = window.getURL();
		childHost = url.getHost();
		parentHost = context.getHostURL().getHost();
		window.setVisible(false);
		if (receiverThread != null) {
			receiverThread.interrupt();
			receiverThread = null;
		}
	}

	/* (non-Javadoc)
	 * @see agentspace.Duplicatable#parent(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void parent(AgentEvent evt, Context context) {
		System.out.println("Chat: parent() called");
		receiver = new ChatReceiver(7011);
		receiverThread = new Thread(receiver);
		receiverThread.start();
		if (childHost != null) {
			sender = new ChatSender(childHost, 7010);
		}
		System.out.println("Chat(parent): child:"+childHost+" to parent:"+parentHost);
		window.setContext(context);
		window.setChatReceiver(receiver);
		window.setChatSender(sender);
		window.setTitle("Chat (original)");
		window.setVisible(true);
	}

	/* (non-Javadoc)
	 * @see agentspace.Duplicatable#child(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void child(AgentEvent evt, Context context) {
		context.setName("Chat-clone");
		System.out.println("Chat: child() called");
		URL url = window.getURL();
		if (url != null) {
			try {
				System.out.println("Chat: child() called url = "+url);
				context.move(url);
			} 
			catch (IOException e) {
				e.printStackTrace();
			} 
			catch (InvalidURLException e) {
				e.printStackTrace();
			}
		}
	}
}
