/*
 * Created on 2005/05/30
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package agent.chat;

import java.awt.Button;
import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;

import agentspace.Context;
import agentspace.IllegalAgentStateException;

public class ChatWindow extends Frame 
implements ActionListener, KeyListener, Serializable, ChatListener {
	private TextArea readArea;
	private TextArea writeArea;
	private TextField target;
	private Button startButton;
	private Context context;
	private ChatSender sender;
	private ChatReceiver receiver;
	
	public static void main(String[] args) {
		ChatWindow window = new ChatWindow();
	}
	
	public ChatWindow() {
		super();
		initWindow();
	}
	
	public void initWindow() {
		setTitle("Chat");
		setBackground(Color.lightGray);
		readArea = new TextArea(4, 40);
		readArea.setText("");
		readArea.setEditable(false);
		readArea.setBackground(Color.black);
		readArea.setForeground(Color.white);
		writeArea = new TextArea(4, 40);
		writeArea.setText("");
		writeArea.addKeyListener(this);
		Panel panel = new Panel();
		if (agentspace.AgentServer.getTargetURL() != null) {
			target = new TextField(agentspace.AgentServer.getTargetURL().toString(), 40);
	    }
	    panel.add(target);
	    startButton = new Button("Copy & Move");
	    startButton.addActionListener(this);
	    panel.add(startButton);

	    Font f = new Font("Dialog", Font.BOLD, 20);
	    readArea.setFont(f);
	    writeArea.setFont(f);
	    add("North",readArea);
	    add("Center",panel);
	    add("South",writeArea);
	    setSize(400, 300);
	    pack();
	    setVisible(true);
	}

	public void setContext(Context context) {
		this.context = context;
	}
	
	public void setChatSender(ChatSender sender) {
		this.sender = sender;
	}
	
	public void setChatReceiver(ChatReceiver receiver) {
		this.receiver = receiver;
		receiver.addChatListener(this);
	}
	
	public URL getURL() {
		URL url = null;
		try {
			url = new URL(target.getText());
		} 
		catch (MalformedURLException ex) {
			ex.printStackTrace();
		}
		return url;
	}
	
	
	public void chatTyped(ChatEvent evt) {
		String s = (String)evt.getSource();
		readArea.append(s);
	}
	
	public void keyPressed(KeyEvent evt) {}
	public void keyReleased(KeyEvent evt) {}
	public void keyTyped(KeyEvent evt) {
//		System.out.println("event = "+evt);
		if (sender != null) {
			sender.send(evt.getKeyChar());
		}
	}
	
	public void actionPerformed(ActionEvent evt) {
		String command = evt.getActionCommand();
		if (evt.getID() == WindowEvent.WINDOW_CLOSING) {
			setVisible(false);
		}
		else if (command.equals("Copy & Move")) {
			System.out.println("Copy & Move");
			if (context != null) {
				try {
					context.duplicate();
				} catch (IllegalAgentStateException ex) {
					ex.printStackTrace();
				}
			}
		}
	}
}
