
package agent.editor;

import agentspace.Context;
import agentspace.Agent;
import agentspace.Duplicatable;
import agentspace.Mobile;
import agentspace.Preservable;
import agentspace.event.AgentEvent;

public class Editor implements Agent, Mobile, Duplicatable, Preservable {
	EditorWindow window = null;

	public Editor() {
		System.out.println("Editor: an instance created.");
	}

	public void create(AgentEvent evt, Context context) {
		System.out.println("Editor: method create() called");
		if (window == null) {
			window = new EditorWindow();
		}
		window.setContext(context);
		window.setVisible(true);
	}

	public void destroy(AgentEvent evt, Context context) {
		System.out.println("Editor: method destroy() called");
		window.setVisible(false);
	}

	public void suspend(AgentEvent evt, Context context) {
		System.out.println("Editor: method suspend() called");
		window.setVisible(false);
	}

	public void resume(AgentEvent evt, Context context) {
		System.out.println("Editor: method resume() called");
		window.setContext(context);
		window.setVisible(true);
	}
	
	public void arrive(AgentEvent evt, Context context) {
		System.out.println("Editor: method arrive() called");
		window.setContext(context);
		window.setVisible(true);
	}

	public void leave(AgentEvent evt, Context context) {
		System.out.println("Editor: method leave() called");
		window.setVisible(false);
	}

	public void duplicate(AgentEvent evt, Context context) {
		System.out.println("Editor: method duplicate() called");
		window.setVisible(false);
	}

	public void parent(AgentEvent evt, Context context) {
		System.out.println("Editor: method parent() called");
		window.setContext(context);
		window.setVisible(true);
	}

	public void child(AgentEvent evt, Context context) {
		System.out.println("Editor: method child() called");
		window.setContext(context);
		window.setVisible(true);
	}
}



