/*
 * Copyright (c) 2005 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2005/05/12
 */


package agentspace.monitor.dialog;

import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

public class AgentDestinationDialog {
	public URL url = null;

	public AgentDestinationDialog(JFrame frame, URL url) {
		JTextField textField = new JTextField(30);
		textField.setText(url.toString());
		textField.setBorder(new TitledBorder("go to URL:"));
	
		Object[] obj = {textField};
		int ans = JOptionPane.showConfirmDialog(frame.getContentPane(), obj, "Dialog", JOptionPane.OK_CANCEL_OPTION);
		if (ans == JOptionPane.YES_OPTION) {
			try {
				url = new URL(textField.getText());
//				System.out.println("AgentDestinationDialog: url = "+url);
			} 
			catch (MalformedURLException e) {
				e.printStackTrace();
				url = null;
			}
		} 
		else if (ans == JOptionPane.CANCEL_OPTION) {
			url = null;
		}
		this.url = url;
	}

	public URL getURL() {
		return url;
	}
}

