/*
 * Copyright (c) 2005 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2005/05/12
 */


package agentspace.monitor.splash;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Toolkit;

import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JWindow;
import javax.swing.plaf.basic.BasicLabelUI;

public class AgentSplashWindow extends JWindow implements Runnable {
  ImageIcon icon = null;
  int time = 0;

  public static void main(String[] args) {
    AgentSplashWindow w = new AgentSplashWindow(
    		new ImageIcon( "agentspace/monitor/images/logo.gif" ), 3000);
  }

  public AgentSplashWindow(ImageIcon icon, int time){
    this.icon = icon;
    this.time = time;
    (new Thread(this)).start();
  }

  public AgentSplashWindow(String name, int time){
    this(new ImageIcon(name), time);
  }

  public void run() {
    Dimension rect = Toolkit.getDefaultToolkit().getScreenSize();
    int width = icon.getIconWidth();
    int height = icon.getIconHeight();
    int x = rect.width/2 - width/2;
    int y = rect.height/2 - height/2;    

    JLabel label = new JLabel( icon );
    label.setUI( new ImageLabelUI() );
    JPanel splash = (JPanel)getContentPane();
    splash.add(label, BorderLayout.CENTER);

    setBounds(x, y, width, height);
    setVisible(true);
    try{
       Thread.sleep(time);
    }catch( Exception e){}
    setVisible(false);
  }

  class ImageLabelUI extends BasicLabelUI {
    public void paint( Graphics g, JComponent c ){ 
      JLabel label = (JLabel)c;
      ImageIcon icon = (ImageIcon)label.getIcon();
      g.drawImage(icon.getImage(), 0, 0, 
		  c.getSize().width, c.getSize().height, c );
    }
  }
}
