/*
 * Copyright (c) 2005 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2005/05/13
 */

package agentspace.monitor.table;

import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

public class AgentTableMap extends AbstractTableModel 
implements TableModelListener {
  protected TableModel model; 

  public TableModel getModel() {
    return model;
  }
  
  public void  setModel(TableModel model) {
    this.model = model; 
    model.addTableModelListener(this); 
  }
  
  public Object getValueAt(int aRow, int aColumn) {
    return model.getValueAt(aRow, aColumn); 
  }
  
  public void setValueAt(Object aValue, int aRow, int aColumn) {
    model.setValueAt(aValue, aRow, aColumn); 
  }
  
  public int getRowCount() {
    return (model == null) ? 0 : model.getRowCount(); 
  }
  
  public int getColumnCount() {
    return (model == null) ? 0 : model.getColumnCount(); 
  }
  
  public String getColumnName(int aColumn) {
    return model.getColumnName(aColumn); 
  }
  
  public Class getColumnClass(int aColumn) {
    return model.getColumnClass(aColumn); 
  }
  
  public boolean isCellEditable(int row, int column) { 
    return model.isCellEditable(row, column); 
  }
  
  public void tableChanged(TableModelEvent evt) {
    fireTableChanged(evt);
  }
}
